# -*- coding: utf-8 -*-
#
#   Copyright (C) 2010 Wei J <mitiao@gmail.com>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License version 2,
#   or (at your option) any later version, as published by the Free
#   Software Foundation
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details
#
#   You should have received a copy of the GNU General Public
#   License along with this program; if not, write to the
#   Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

import os
import re
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4 import uic
from PyKDE4.plasma import Plasma
from PyKDE4 import plasmascript
from PyKDE4.kdecore import *
from PyKDE4.kdeui import *

pingcmd = "ping -c 2 google.com"
pause = "sleep 2"

def check_network(self):
    if (os.system(pingcmd) == 0):
        print "webpage widget detected network connection..."
        pass
    else:
        os.system(pause)
        check_network()

class WebSnippetPlus(plasmascript.Applet):
    def __init__(self,parent,args=None):
        plasmascript.Applet.__init__(self,parent)
        self.url = ""
        self.interval = 1

    def init(self):
        self.general_config = self.config("General")
        self.fromGeneralConfig()
        
        self.setHasConfigurationInterface(True)
        
        self.theme = Plasma.Svg(self)
        self.theme.setImagePath("widgets/background")
        self.setBackgroundHints(Plasma.Applet.DefaultBackground)
        self.setAspectRatioMode(Plasma.IgnoreAspectRatio)
        self.resize(300, 400)

        self.timerid = self.startTimer(1000 * 60 * self.interval)
        
        print "Loading webpage on widget..."
        self.layout = QGraphicsLinearLayout(Qt.Horizontal, self.applet)
        self.webView = Plasma.WebView()
        self.webView.setAutoFillBackground(True)
        self.webView.setUrl(KUrl(self.url))
        self.layout.addItem(self.webView)
        self.setLayout(self.layout)
        
    def configChanged(self):
        self.fromGeneralConfig()
        plasmascript.Applet.configChanged(self)

        p = re.compile("^http://.*")
        if (p.match(self.url) == None):
            self.url = "http://" + self.url
        else:
            pass
        
        self.configOK()
        self.update()

    def fromGeneralConfig(self):
        self.url = self.general_config.readEntry("url",QString("http://iphone.facebook.com")).toString()
        self.interval, success = self.general_config.readEntry("interval",1).toInt()

    def configOK(self):
        self.killTimer(self.timerid)
        self.timerid = self.startTimer(1000 * 60 * self.interval)
        self.webView.setUrl(KUrl(self.url))
        
    def reloadPage(self):
        self.webView.page().triggerAction(self.webView.page().Reload)
        
    def timerEvent(self, event):
        self.reloadPage()
        self.update()
        
def CreateApplet(parent):
    return WebSnippetPlus(parent)
